package com.gxwebsoft.oa.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.oa.service.OaTaskUserService;
import com.gxwebsoft.oa.entity.OaTaskUser;
import com.gxwebsoft.oa.param.OaTaskUserParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 工单成员控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 20:57:42
 */
@Tag(name = "工单成员管理")
@RestController
@RequestMapping("/api/oa/oa-task-user")
public class OaTaskUserController extends BaseController {
    @Resource
    private OaTaskUserService oaTaskUserService;

    @Operation(summary = "分页查询工单成员")
    @GetMapping("/page")
    public ApiResult<PageResult<OaTaskUser>> page(OaTaskUserParam param) {
        // 使用关联查询
        return success(oaTaskUserService.pageRel(param));
    }

    @Operation(summary = "查询全部工单成员")
    @GetMapping()
    public ApiResult<List<OaTaskUser>> list(OaTaskUserParam param) {
        PageParam<OaTaskUser, OaTaskUserParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(oaTaskUserService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(oaTaskUserService.listRel(param));
    }

    @PreAuthorize("hasAuthority('oa:oaTaskUser:list')")
    @OperationLog
    @Operation(summary = "根据id查询工单成员")
    @GetMapping("/{id}")
    public ApiResult<OaTaskUser> get(@PathVariable("id") Integer id) {
        return success(oaTaskUserService.getById(id));
        // 使用关联查询
        //return success(oaTaskUserService.getByIdRel(id));
    }

    @Operation(summary = "添加工单成员")
    @PostMapping()
    public ApiResult<?> save(@RequestBody OaTaskUser oaTaskUser) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          oaTaskUser.setUserId(loginUser.getUserId());
        }
        if (oaTaskUserService.save(oaTaskUser)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @Operation(summary = "修改工单成员")
    @PutMapping()
    public ApiResult<?> update(@RequestBody OaTaskUser oaTaskUser) {
        if (oaTaskUserService.updateById(oaTaskUser)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @Operation(summary = "删除工单成员")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (oaTaskUserService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @Operation(summary = "批量添加工单成员")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<OaTaskUser> list) {
        if (oaTaskUserService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @Operation(summary = "批量修改工单成员")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<OaTaskUser> batchParam) {
        if (batchParam.update(oaTaskUserService, "task_user_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @Operation(summary = "批量删除工单成员")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (oaTaskUserService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
